type operator = Add | Sub | Mul | Div | Pow

type expr =
    Binop of expr * operator * expr
  | Lit of string
  | Id of string
  | FuncApplication of string * expr

type point_literal = {
  x: expr;
  y: expr;
  z: expr;
}

type point =
    PointId of string
  | PointLit of point_literal

type matrix =
    MatrixChain of string list
  | MatrixLit of expr list

type def =
    FuncDef of string * string * expr
  | ConstDef of string * expr
  | MatrixDef of string * matrix
  | PointDef of string * point
  | PointsDef of string * point list

type stmt =
    AddPoint of string * point
  | Render of string * string * expr
  | Sleep of expr
  | Def of def
  | ForLoop of string * string * string * stmt list

type program = stmt list
